%define version 0.3.2
# The define of the version macro will be inserted above this line when a
# tarball is made

Name: photopub
Version: %{version}
Release: 1
Group: Applications/Internet
Summary: Publishes photos on the web in a highly customisable manner
License: GPL
Vendor: Project Purple <http://www.earth.li/projectpurple/>
Distribution: Red Hat Linux
Packager: PhotoPub development team <http://urchin.earth.li/projects/photopub/>
URL: http://urchin.earth.li/projects/photopub/
Source: photopub-%{version}.tar.gz
BuildRoot: /var/tmp/photopub-build
BuildRequires: perl
PreReq: patch, diffutils
Requires: apache
BuildArchitectures: noarch

%define __find_requires dist/redhat/find-requires
%define __find_provides dist/redhat/find-provides

%description 

PhotoPub is a perl application for publishing photos, particularly those
taken with a digital camera, on the web. It is designed so that once it is
configured, new photos can be quickly published. Almost every aspect of the
HTML it outputs can be customised.

%prep
%setup

%build
# empty since it's all perl scripts

%install

rm -rf $RPM_BUILD_ROOT
for d in /etc /usr/lib/photopub/PhotoPub \
         /usr/lib/photopub/utils /usr/lib/photopub/cgi-bin \
         /etc/httpd/conf.d
   do install -d -m 755 $RPM_BUILD_ROOT$d
done

# will get changed to 2775 root.apache by the %files section
install -d -m 755 $RPM_BUILD_ROOT/var/cache/photopub 

dist/mungefile.pl configfind dist/configfind.global < PhotoPub/Config.pm \
   > $RPM_BUILD_ROOT/usr/lib/photopub/PhotoPub/Config.pm
chmod 644 $RPM_BUILD_ROOT/usr/lib/photopub/PhotoPub/Config.pm

for d in Handlers Images Ages Annots Cache Global CGIBase CLBase \
         Images Options Utils AlbumHelper RangeHelper DisplayHelper FileInfo
   do install -m 644 PhotoPub/$d.pm $RPM_BUILD_ROOT/usr/lib/photopub/PhotoPub/$d.pm
done

for d in album range embed display
   do dist/mungefile.pl libsetup dist/libsetup.global < cgi-bin/$d.pl \
         > $RPM_BUILD_ROOT/usr/lib/photopub/cgi-bin/$d.pl
   chmod 755 $RPM_BUILD_ROOT/usr/lib/photopub/cgi-bin/$d.pl
done

for d in checkconfig
   do dist/mungefile.pl libsetup dist/libsetup.global < utils/$d.pl \
        > $RPM_BUILD_ROOT/usr/lib/photopub/utils/$d.pl
   chmod 755 $RPM_BUILD_ROOT/usr/lib/photopub/utils/$d.pl
done

install -m 755 dist/mungefile.pl $RPM_BUILD_ROOT/usr/lib/photopub/utils/

cd dist

for d in `find templates -type d`
   do install -d -m 755 $RPM_BUILD_ROOT/etc/photopub/$d
done

for d in `find templates -type f`
   do install -m 644 $d $RPM_BUILD_ROOT/etc/photopub/$d
done

cd ..

install -m 644 dist/photopubrc $RPM_BUILD_ROOT/etc/photopubrc

install -m 644 dist/apache.conf $RPM_BUILD_ROOT/etc/httpd/conf.d/photopub.conf

%clean
rm -rf $RPM_BUILD_ROOT

%post
# Idiot RPM runs postinstall before preuninstall on upgrade
# So we need to only do all this if this *isn't* an upgrade
# (and hope that we don't change the fragment to be inserted later)

if [ $1 -eq 1 ]; then

if [ ! -f /etc/photopub/httpd.conf.nomunge ]; then
   FRAGMENT=`mktemp -q /etc/httpd/conf/httpd.conf.fragment.XXXXXX`
   if [ $? -ne 0 ]; then
      echo "$0: Can't create temp file, exiting..."
      exit 1
   fi

   HTTPDCONF=`mktemp -q /etc/httpd/conf/httpd.conf.XXXXXX`
   if [ $? -ne 0 ]; then
      echo "$0: Can't create temp file, exiting..."
      exit 1
   fi

   cat > $FRAGMENT << END
#---photopub---

# Changes to this section will be lost if you remove or upgrade PhotoPub
# You can safely move it elsewhere in this file if you wish
# Do not alter the delimiters above and below or bad things will happen!

Include /etc/httpd/conf.d/photopub.conf

#---endphotopub---
END

   if [ -f /etc/photopub/httpd.conf.diff ]; then
      if [ `patch -F 0 --dry-run /etc/httpd/conf/httpd.conf \
             < /etc/photopub/httpd.conf.diff \
             2>&1 | wc -l` -eq 1 ]; then
         patch /etc/httpd/conf/httpd.conf < /etc/photopub/httpd.conf.diff
      fi
      rm -f /etc/photopub/httpd.conf.diff
   fi

   cp -p /etc/httpd/conf/httpd.conf $HTTPDCONF # to get the ownership/perms right
   /usr/lib/photopub/utils/mungefile.pl -a photopub $FRAGMENT \
      < /etc/httpd/conf/httpd.conf > $HTTPDCONF

   mv $HTTPDCONF /etc/httpd/conf/httpd.conf
   rm $FRAGMENT
fi

fi

%preun
# See comments for postinstall script for why we do the first test

if [ $1 -eq 0 ]; then

if [ ! -f /etc/photopub/httpd.conf.nomunge ]; then

   FRAGMENT=`mktemp -q /etc/httpd/conf/httpd.conf.fragment.XXXXXX`
   if [ $? -ne 0 ]; then
      echo "$0: Can't create temp file, exiting..."
      exit 1
   fi

   HTTPDCONF=`mktemp -q /etc/httpd/conf/httpd.conf.XXXXXX`
   if [ $? -ne 0 ]; then
      echo "$0: Can't create temp file, exiting..."
      exit 1
   fi

   cp -p /etc/httpd/conf/httpd.conf $HTTPDCONF # to get the ownership/perms right
   /usr/lib/photopub/utils/mungefile.pl photopub $FRAGMENT \
      < /etc/httpd/conf/httpd.conf > $HTTPDCONF

   diff -u $HTTPDCONF /etc/httpd/conf/httpd.conf > /etc/photopub/httpd.conf.diff \
      && true

   mv $HTTPDCONF /etc/httpd/conf/httpd.conf
   rm $FRAGMENT
fi

fi

%files
# need to build files list so the list of template packages isn't hardcoded
%defattr (-,root,root)
%config(noreplace) /etc/photopubrc
%dir /etc/httpd/conf.d
%config(noreplace) /etc/httpd/conf.d/photopub.conf
%attr(2775,root,apache) /var/cache/photopub
/usr/lib/photopub
%dir /etc/photopub
%dir /etc/photopub/templates
%dir /etc/photopub/templates/basic
%config(noreplace) /etc/photopub/templates/conf
%config(noreplace) /etc/photopub/templates/basic/*
%doc README doc/*

%changelog
%changelog
* Sat Oct 11 2003 PhotoPub Development Team <photopub-devel@lists.urchin.earth.li> 0.3.2-1
- Fixed some bugs with included configs
- Fixed a bug with aliased photos
- Removed a confusing error message ("Possible recursion in templatealias...")
- HTML version of changelog now available
- Cleaned up slideshow template a bit

* Sat Sep 27 2003 PhotoPub Development Team <photopub-devel@lists.urchin.earth.li> 0.3.1-1
- Fixed bug with trailing '/' characters
- Fixed bugs with reading files from executable but not readable directories
- Fixed bug with subdirectories in <imagedirs>

* Fri Aug 15 2003 PhotoPub Development Team <photopub-devel@lists.urchin.earth.li> 0.3.0-1
- This is a new "middle" release in view of the significant changes made.
  A lot of cleaning up is still to be done, however. Currently no templates
  demonstrating the new features are included in the distribution.
- New script and associated template format "embed". This allows single
  photos to be displayed embedded in an HTML page
- titles=albumname option to range script replaced with album=albumname,
  the idea being that other things might also want to know what the album is
  so a more generally named parameter is appropriate
- "Inner" loops in range templates allow more sophisticated layout. For 
  example, we can have a three-column table where the rows are alternately
  three photos followed by the three captions for those photos.
- Significant performance work
- Removed a perl warning from Ages.pm

* Tue Aug 12 2003 PhotoPub Development Team <photopub-devel@lists.urchin.earth.li> 0.1.8-1
- Distribution range templates consistently display titles
  (where they exist)
- Remove exif info and comments from mogrified images to reduce size
- Fix perl warning in Utils.pm

* Sun Aug 3 2003 PhotoPub Development Team <photopub-devel@lists.urchin.earth.li> 0.1.7-1
- Fixed bug with relative path handling in config files
- Added relative path handling for aliases
- Added "first" and "last" link options to allow loops
- Added "elseprev" and "elsenext" tags
- Fixed bug with multiple user configs being loaded simultaneously
- Added searching feature
- Added $nexturl and $prevurl for paged templates
- Added "nick" templates to distribution
- Removed "titlehash" in favour of titles=albumname option to range

* Tue Feb 18 2003 PhotoPub Development Team <photopub-devel@lists.urchin.earth.li> 0.1.6-1
- Fixed permissions on /var/cache/photopub
- Stopped a warning that was being sent to STDERR
- Made quick start guide for manual.html
- Removed some unhelpful documentation files from the distribution
- Stopped configuration warnings causing a CGI error
- Fixed bug with subdirectory handling
- Simplified Apache configuration
- Added '#' to the list of allowable characters in a path

* Tue Jan 21 2003 PhotoPub Development Team <photopub-devel@lists.urchin.earth.li> 0.1.5-1
- Proper changelogs added
- Copyright notice updated
- Make it possible to "include" other config files
- Fix for perl 5.00503
- Aliasing of templates (e.g. make the templates in / be those from /basic)
- Call existing distribution templates /basic/... rather than /...
  (but alias / to /basic)
- Work around RPM silliness for config file munging scripts
  (It runs post install scripts before pre uninstall scripts on upgrading,
   which makes things a bit tricky)

* Thu Jan 9 2003 PhotoPub Development Team <photopub-devel@lists.urchin.earth.li> 0.1.4-1
- Bug fix - aliases etc were broken in 0.1.3

* Thu Jan 9 2003 PhotoPub Development Team <photopub-devel@lists.urchin.earth.li> 0.1.3-1
- Various performance work

* Tue Jan 7 2003 PhotoPub Development Team <photopub-devel@lists.urchin.earth.li> 0.1.2-1
- Make album output incremental to increase speed of first response

* Mon Jan 6 2003 PhotoPub Development Team <photopub-devel@lists.urchin.earth.li> 0.1.1-1
- First public release

